Name:           oraculum
# Don't forget to also change oraculum/__init__.py
Version:        0.2.1
Release:        1%{?dist}
Summary:        Backend and API for Fedora QA Dashboard

License:        GPLv2+
URL:            https://pagure.io/fedora-qa/oraculum
Source0:        https://releases.pagure.org/fedora-qa/%{name}/%{name}-%{version}.tar.gz

BuildArch:      noarch


BuildRequires:  systemd-devel
BuildRequires:  systemd
BuildRequires:  python3-devel
BuildRequires:  python3-setuptools

# Test requirements, we need to list these as there is no python3 builddep generator
BuildRequires:  python3-redis
BuildRequires:  python3-requests
BuildRequires:  python3-pytz
BuildRequires:  python3-igraph
BuildRequires:  python3-dateutil
BuildRequires:  python3-bugzilla
BuildRequires:  python3-bodhi-client
BuildRequires:  python3-koji
BuildRequires:  python3-pygments
BuildRequires:  python3-icalendar
BuildRequires:  python3-fedfind
BuildRequires:  python3-flask
BuildRequires:  python3-flask-sqlalchemy
BuildRequires:  python3-flask-oidc
BuildRequires:  python3-flask-login
BuildRequires:  python3-flask-cors
BuildRequires:  python3-celery
BuildRequires:  python3-alembic
BuildRequires:  python3-pytest
BuildRequires:  python3-mock
BuildRequires:  python3-pyyaml

Requires:       python3-gunicorn
Requires:       nginx
Requires:       redis

%description
Backend and API for Fedora QA Dashboard

%prep
%setup -q

%build
%py3_build

%install
%py3_install

# service file and nginx settings
mkdir -p %{buildroot}%{_datadir}/oraculum
mkdir -p %{buildroot}%{_sysconfdir}/oraculum

# Fix client_secrets.json location
sed -i 's,./conf/client_secrets.json.example,/etc/oraculum/client_secrets.json,' conf/settings.py.example

# alembic config and data
cp -r alembic %{buildroot}%{_datadir}/oraculum/.
install alembic.ini %{buildroot}%{_datadir}/oraculum/.

install -p -m 644 conf/settings.py.example %{buildroot}%{_sysconfdir}/oraculum/settings.py
install -p -m 644 conf/client_secrets.json.example %{buildroot}%{_sysconfdir}/oraculum/client_secrets.json

install -d -m 755 %{buildroot}/etc/nginx/conf.d/
install -p -m 644 conf/oraculum.conf.nginx %{buildroot}/etc/nginx/conf.d/oraculum.conf

mkdir -p %{buildroot}/%{_unitdir}
install -p -m 644 conf/oraculum.service %{buildroot}/%{_unitdir}/oraculum.service
install -p -m 644 conf/oraculum_worker.service %{buildroot}/%{_unitdir}/oraculum_worker.service
install -p -m 644 conf/oraculum_beat.service %{buildroot}/%{_unitdir}/oraculum_beat.service

%post
%systemd_post oraculum.service
%systemd_post oraculum_worker.service
%systemd_post oraculum_beat.service

%preun
%systemd_preun oraculum.service
%systemd_preun oraculum_worker.service
%systemd_preun oraculum_beat.service

%postun
%systemd_postun_with_restart oraculum.service
%systemd_postun_with_restart oraculum_worker.service
%systemd_postun_with_restart oraculum_beat.service

%check
TEST=true %pytest
# Remove compiled .py files from /etc after os_install_post
rm -f %{buildroot}%{_sysconfdir}/testcloud/*.py{c,o}
rm -rf %{buildroot}%{_sysconfdir}/testcloud/__pycache__

%files
%doc README.md conf/*
%{python3_sitelib}/oraculum/
%{python3_sitelib}/*.egg-info/

%{_unitdir}/oraculum.service
%{_unitdir}/oraculum_worker.service
%{_unitdir}/oraculum_beat.service

%{_bindir}/oraculum
%dir %{_sysconfdir}/oraculum
%dir %{_datadir}/oraculum
%{_datadir}/oraculum/*

%config(noreplace) %{_sysconfdir}/oraculum/settings.py
%config(noreplace) %{_sysconfdir}/oraculum/client_secrets.json
%config(noreplace) %{_sysconfdir}/nginx/conf.d/oraculum.conf

%changelog
* Tue Oct 27 2020 Frantisek Zatloukal <fzatlouk@redhat.com> - 0.2.1-1
- Release 0.2.1

* Tue Oct 27 2020 Frantisek Zatloukal <fzatlouk@redhat.com> - 0.2.0-1
- Release 0.2.0

* Mon Jul 27 2020 Frantisek Zatloukal <fzatlouk@redhat.com> - 0.1.0-1
- Release 0.1.0

* Mon Feb 10 2020 Frantisek Zatloukal <fzatlouk@redhat.com> - 0.0.3-1
- Release 0.0.3

* Fri Feb 15 2019 Lukas Brabec <lbrabec@redhat.com> - 0.0.2-1
- Bump to 0.0.2

* Wed Feb 13 2019 Lukas Brabec <lbrabec@redhat.com> - 0.0.1-3
- Better summary and description

* Thu Feb 07 2019 Frantisek Zatloukal <fzatlouk@redhat.com> - 0.0.1-2
- Improved packaging

* Thu Feb 06 2014 Josef Skladanka <jskladan@redhat.com> - 0.0.1-1
- initial packaging
